/* C_17DOS2.C */

/* *************************************************************** */
/* Dieses Programm liest eine Serie von Wrtern der Kommandozeile  */
/* und zeigt alle, mit Ausnahme des letzten Wortes an.             */
/* Dieses ist eine Zeichenfolge, die fr Eingabevergleiche.        */
/* Ein Zeichen wird von der Tastatur gelesen. Wenn es eines aus    */
/* der Vergleichsliste ist, wird dessen Nummer als ERRORLEVEL      */
/* zu DOS zurckgegeben. Wenn das Zeichen nicht existiert          */
/* wird 0 zurckgegeben. Beispiel folgt:                           */
/*                                                                 */
/* C_17DOS2 Welches Modell wollen Sie? ALR%3T                      */
/*                                                                 */
/* Welches Modell wollen Sie?   <---- angezeigt                    */
/*    a oder A,          errorlevel = 1                            */
/*    l oder L, 	 errorlevel = 2                                   */
/*    r oder R, 	 errorlevel = 3                                   */
/*    %       , 	 errorlevel = 4                                   */
/*    3       , 	 errorlevel = 5                                   */
/*    t oder T, 	 errorlevel = 6                                   */
/*    Jede andere Taste, errorlevel = 0                            */
/*                                                                 */
/*  Die Frage mu auf einer Zeile Platz haben                      */
/*  Bis zu neun Tasten knnen benutzt werden                       */
/*  errorlevel kann in einer Batch-Datei abgefragt werden          */
/* *************************************************************** */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>

void main(int argumentzahl, char *argumentname[])
{
   int   index;                                      /* ein Zhler */
   int   c;                               /* Zeichen zum Vergleich */
   int   errorlevel;                  /* resultierender errorlevel */
   char  naechstes_zeichen; /* in der Vergleichsschleife verwendet */
   char *zeiger;                                    /* Hilfszeiger */

                     /* At least one group must be used for this   */
		     /* fileargumentname, and one group used for the       */
                     /* required fields, so less than three allows */
		     /* for no question.                           */

   if (argumentzahl < 3)
   {
      printf("Keine Frage in dieser Kommandozeile\n");
      exit(0);
   }

			 /* Ausgabe der Wrter 2 to n-1, die Frage */
   argumentzahl--;
   for(index = 1;index < argumentzahl;index++)
      printf("%s ",argumentname[index]);

						/* Benutzerantwort */
   c = getch();
   printf("%c\n",c);
   if (islower(c)) c = toupper(c);
   zeiger = argumentname[argumentzahl];        /* letztes Argument */

   errorlevel = 0;
   index = 0;
   do            /* Suche nach erlaubten Antworten im letzten Wort */
   {
      naechstes_zeichen = *(zeiger + index);
      if (islower(naechstes_zeichen))
	 naechstes_zeichen = toupper(naechstes_zeichen);
      if(naechstes_zeichen == c)                /* bereinstimmung */
	 errorlevel = index + 1;             /* Merke Argumentzahl */
      index++;
   }
   while (*(zeiger + index));

   exit(errorlevel);                        /* Rckgabe zum System */
}

/* C_17DOS2.C */
