
/* CPPKLA1.C */

/* In C kann man auch objekt-orientiert programmieren
   Mit globalen Daten, ohne Parameterbergabe allerdings nur mit einem Objekt
*/

#include <stdlib.h>
#include <stdio.h>

char *wurm=0;                     /*   VARIABLE                */

void wurm_mach(int laenge);       /*   FUNKTIONEN,             */
void wurm_kill(void);             /*   DIE MIT                 */
void wurm_loch(int position);     /*   DER VARIABLEN           */
void wurm_zeig(void);             /*   ARBEITEN                */

void main()
{
  /* da immer dieselbe globale Variable verwendet wird
     gibt es eigentlich nur einen Wurm

     wollten wir mehrere Wrmer, mten wir mit Parameter-bergabe
     arbeiten, siehe CPPKLA2.C
  */
  
  wurm_mach(20);
  wurm_zeig();
  wurm_loch(5);
  wurm_zeig();

  wurm_mach(10);
  wurm_zeig();
  wurm_loch(2);
  wurm_zeig();

  wurm_kill();
}

void wurm_mach(int laenge)
{
  int i;

  wurm=(char*)malloc(laenge+1);
  for (i=0; i<laenge; i++)
    wurm[i]='*';
  wurm[i]=0;
}

void wurm_kill()
{
  free(wurm);
}

void wurm_loch(int position)
{
  wurm[position]='.';
}

void wurm_zeig(void)
{
  printf("%s\n",wurm);
}


